
/**
 * Title:        DEA<p>
 * Description:  Simulation eines determinitischen endlichen Automaten<p>
 * Copyright:    Copyright (c) heljanic<p>
 * Company:      <p>
 * @author heljanic
 * @version 1.0
 */
package dea;

import javax.swing.table.*;
import java.util.*;
import java.io.*;

public class DataModel extends AbstractTableModel implements Serializable{
  private Vector rows = new Vector();
  char[] alphabet = { '0', '1' };

  boolean isDEA = false;

  public DataModel() {
  }

  public int getColumnCount() {
    //TODO: implement this javax.swing.table.AbstractTableModel abstract method
    return alphabet.length + 1;
  }

  public Object getValueIntAt(int row, int col) {
    //TODO: implement this javax.swing.table.AbstractTableModel abstract method
    if ( col == 0 ) return Zustand.buildZustand(row, this.getRowCount()) + "  /E= " + ((Zustand) (rows.get(row))).accepted ;
   return new Integer(((Zustand) (rows.get(row))).indices[col-1]);
  }

  public Object getValueAt(int row, int col) {
    //TODO: implement this javax.swing.table.AbstractTableModel abstract method
    if (isDEA) {
      if ( col == 0 ) return Zustand.buildZustand(row, this.getRowCount()) + "  /E= " + ((Zustand) (rows.get(row))).accepted ;
      return Zustand.buildZustand(((Zustand) (rows.get(row))).indices[col-1], this.getRowCount());
    } else {
      if ( col == 0 ) return "z" + row + "  /E= " + ((Zustand) (rows.get(row))).accepted ;
      return new Integer(((Zustand) (rows.get(row))).indices[col-1]);
    }
  }

  public int getRowCount() {
    //TODO: implement this javax.swing.table.AbstractTableModel abstract method
    return rows.size();
  }

  public void addRow() {
    rows.add(new Zustand(alphabet.length));
    this.fireTableDataChanged();
  }

  public void setValueAt(int row, int col, int value) {
    if (col == 0) return;
    ((Zustand) (rows.get(row))).indices[col-1] = value;
  }

  /** Speichert serialisierte Daten in den angegebenen File */
  public void save(File saveFile) {
    try {
      FileOutputStream fileOutStream = new FileOutputStream(saveFile);
      ObjectOutputStream objOutStream = new ObjectOutputStream(fileOutStream);
      for (int i = 0; i < rows.size(); i++) objOutStream.writeObject((Zustand) rows.get(i));
      objOutStream.flush();
      objOutStream.close();
      fileOutStream.close();
    } catch (Exception exc) {}
  }

  /** ffnen serialisierte Daten aus dem angegebenen File */
  public void open(File openFile) {
    Zustand obj;
    rows.removeAllElements();
    try {
      FileInputStream fileInStream = new FileInputStream(openFile);
      ObjectInputStream objInStream = new ObjectInputStream(fileInStream);
      while ((obj = (Zustand) objInStream.readObject()) != null) {
        rows.add(obj);
      }
      objInStream.close();
      fileInStream.close();
    } catch (Exception exc) {}
    this.fireTableStructureChanged();
  }

  public Zustand getZustand(int row) {
    if (row >= rows.size()) return null;
    return (Zustand) rows.get(row);
  }

  public String getColumnName(int col) {
    if (col==0) return "Zustnde";
    if (col==1) return "0";
    if (col==2) return "1";
    return "";
  }

//  public boolean isCellEditable(int a, int b) { return true; }

}