
/**
 * Title:        DEA<p>
 * Description:  Simulation eines determinitischen endlichen Automaten<p>
 * Copyright:    Copyright (c) heljanic<p>
 * Company:      <p>
 * @author heljanic
 * @version 1.0
 */
package dea;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import javax.swing.table.*;

public class MainFrame extends JFrame {
  int curRow;
  int curCol;
  int curZust;

  JFileChooser jfc = new JFileChooser();
  DataModel model = new DataModel();
  DataModel newModel = null;
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel1 = new JLabel();
  JTable table = new JTable();
  JButton butNew = new JButton();

  TableColumn column1;
  TableColumn column2;
  JComboBox cmbValue = new JComboBox();
  JMenuItem menSave = new JMenuItem();
  JMenuItem menOpen = new JMenuItem();
  JButton butTest = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextArea txtOutput = new JTextArea();
  JTextField txtTest = new JTextField();

  DefaultCellEditor dfltEditor = new DefaultCellEditor(cmbValue);
  JComboBox cmbAccept = new JComboBox();
  JButton butNEAToDEA = new JButton();
  JButton butToNEA = new JButton();

  //Construct the frame
  public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
//      table.setCellEditor(dfltEditor);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(592, 553));
    this.setTitle("DEA");
    statusBar.setText(" ");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    jPanel1.setLayout(null);
    jScrollPane1.setBounds(new Rectangle(16, 9, 548, 169));
    jLabel1.setText("aktuelle Zelle:");
    jLabel1.setBounds(new Rectangle(22, 188, 122, 27));
    table.setCellSelectionEnabled(true);
    table.setModel(model);
    table.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        table_mouseClicked(e);
      }
    });
    butNew.setText("neuen Zustand anlegen");
    butNew.setBounds(new Rectangle(338, 180, 226, 30));
    butNew.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        butNew_actionPerformed(e);
      }
    });
    cmbValue.setBounds(new Rectangle(155, 189, 88, 24));
    cmbValue.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cmbValue_actionPerformed(e);
      }
    });
    menSave.setText("Save");
    menSave.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        menSave_actionPerformed(e);
      }
    });
    menOpen.setText("Open");
    menOpen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        menOpen_actionPerformed(e);
      }
    });
    butTest.setText("Wort testen");
    butTest.setEnabled(false);
    butTest.setBounds(new Rectangle(387, 280, 171, 23));
    butTest.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        butTest_actionPerformed(e);
      }
    });
    jScrollPane2.setBounds(new Rectangle(17, 305, 547, 169));
    txtTest.setText("01001");
    txtTest.setBounds(new Rectangle(17, 280, 367, 24));
    cmbAccept.setBounds(new Rectangle(155, 190, 88, 24));
    cmbAccept.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cmbAccept_actionPerformed(e);
      }
    });
    butNEAToDEA.setText("NEA nach DEA");
    butNEAToDEA.setBounds(new Rectangle(338, 212, 226, 31));
    butNEAToDEA.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        butNEAToDEA_actionPerformed(e);
      }
    });
    butToNEA.setText("zurck zu NEA");
    butToNEA.setBounds(new Rectangle(338, 245, 226, 28));
    butToNEA.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        butToNEA_actionPerformed(e);
      }
    });
    menuFile.add(menuFileExit);
    menuFile.add(menSave);
    menuFile.add(menOpen);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(table, null);
    jPanel1.add(butNew, null);
    jPanel1.add(cmbValue, null);
    jPanel1.add(jLabel1, null);
    jPanel1.add(cmbAccept, null);
    jPanel1.add(jScrollPane2, null);
    jPanel1.add(txtTest, null);
    jPanel1.add(butTest, null);
    jPanel1.add(butNEAToDEA, null);
    jPanel1.add(butToNEA, null);
    jScrollPane2.getViewport().add(txtOutput, null);
    cmbAccept.addItem(new Boolean(false));
    cmbAccept.addItem(new Boolean(true));
    cmbAccept.setVisible(false);
    cmbValue.setVisible(false);
    jLabel1.setVisible(false);
    butTest.setEnabled(false);
    butToNEA.setEnabled(false);
    butNEAToDEA.setEnabled(false);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    MainFrame_AboutBox dlg = new MainFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void butNew_actionPerformed(ActionEvent e) {
    butNEAToDEA.setEnabled(true);
    model.addRow();
    cmbValue.removeAllItems();
    int max = 2 << model.getRowCount()-1;
    System.err.println("max " + max );
    for (int i=0; i< max; i++) {
      cmbValue.addItem(Zustand.buildZustand(i, model.getRowCount() ));
    }
  }

  void table_mouseClicked(MouseEvent e) {
      if (table.getSelectedColumn() == 0) {
        curZust = table.getSelectedRow();
        cmbAccept.setVisible(true);
        cmbValue.setVisible(false);
        jLabel1.setText("Endzustand z "+ curZust);
        jLabel1.setVisible(true);
        if (model.getZustand(curZust).accepted) cmbAccept.setSelectedIndex(1);
        else cmbAccept.setSelectedIndex(0);
        System.err.println(""+ model.getZustand(curZust).accepted);
        return;
      }
      curZust = table.getSelectedRow();
      cmbAccept.setVisible(false);
      cmbValue.setVisible(true);
      jLabel1.setText("aktuelle Zelle");
      jLabel1.setVisible(true);

      curCol = table.getSelectedColumn();
      curRow = table.getSelectedRow();
      cmbValue.setSelectedIndex(((Integer) model.getValueIntAt(curRow, curCol)).intValue());
  }

  void cmbValue_actionPerformed(ActionEvent e) {
    model.setValueAt(curRow, curCol, cmbValue.getSelectedIndex());
    model.fireTableDataChanged();
  }

  void menSave_actionPerformed(ActionEvent e) {
    switch(jfc.showSaveDialog(this)) {
      case JFileChooser.APPROVE_OPTION:
        File saveFile = jfc.getSelectedFile();
        model.save(saveFile);
        break;
      default :
    }
  }

  void menOpen_actionPerformed(ActionEvent e) {
    butNEAToDEA.setEnabled(true);
    switch(jfc.showOpenDialog(this)) {
      case JFileChooser.APPROVE_OPTION:
        File openFile = jfc.getSelectedFile();
        model.open(openFile);
        cmbValue.removeAllItems();
        for (int i=0; i<model.getRowCount(); i++)
          cmbValue.addItem("z"+i);
        break;
      default :
    }

  }

  void butTest_actionPerformed(ActionEvent e) {
    if (newModel == null) return ;
    int row = 1;
    boolean found = false;
    String s = txtTest.getText();
    String result = "";
    try {
      while (!s.equals("")) {
       result += " -> (" + s + ", " + Zustand.buildZustand(row, model.getRowCount()) + ")";
        char first = MyString.first(s);
        found=false;
        for (int i=0; i<newModel.alphabet.length; i++) {
          if (model.alphabet[i] == first) {
            // found next one
            found = true;
            row = ((Integer) newModel.getValueIntAt(row, i+1)).intValue();
            s = MyString.rest(s);
            break;
          }
        }
        if (found) {
        } else {
        System.err.println("not part of alphabet");
          JOptionPane.showMessageDialog(this,"Das Zeichen " + first + " ist nicht Teil des Alphabets!");
          // char was not a part of the alphabet.
          txtOutput.setText("FEHLER:\nDas Zeichen " + first + " ist nicht Teil des Alphabets!");
          return;
        }
      }
    } catch (Exception exc) {}
    result += " -> (" + "-" + ", " + Zustand.buildZustand(row, model.getRowCount()) +")";
    if (newModel.getZustand(row).accepted ) result += "\ndas Wort wird akzeptiert";
    else result += "\ndas Wort wird nicht akzeptiert";
    txtOutput.setText(result);
  }

  void cmbAccept_actionPerformed(ActionEvent e) {
   if (model.getZustand(curZust) == null ) return;
    if(cmbAccept.getSelectedIndex() == 0) {
      //System.err.println("set false");

      model.getZustand(curZust).accepted = false;
    }
    if(cmbAccept.getSelectedIndex() == 1) {
      model.getZustand(curZust).accepted = true;
      //System.err.println("set true");
    }
  }

  void butNEAToDEA_actionPerformed(ActionEvent e) {
    menSave.setEnabled(false);
    butNEAToDEA.setEnabled(false);
    butNew.setEnabled(false);
    cmbValue.setEnabled(false);
    cmbAccept.setEnabled(false);
    butTest.setEnabled(true);
    butToNEA.setEnabled(true);

    newModel = new DataModel();
    newModel.alphabet = model.alphabet;

    int max = 1 << model.getRowCount();
    int counter = 1;

    // kopiere ersten beiden zustnde.
    newModel.addRow();
    newModel.addRow();
    int pow=1;
    for (int i=0; i< newModel.alphabet.length; i++) {
      pow = 1;
      newModel.getZustand(0).indices[i] = 0;
      newModel.getZustand(1).indices[i] = model.getZustand(0).indices[i];
    }

    for (int i=2; i<max; i++) {
      // durchluft Potenzmenge

      // legt neue Zeile an.
      newModel.addRow();

      int twoPoweredBy = -1;

      // ist i zweierpotenz ?
      pow = 1;
      for (int j=0; j<model.getRowCount(); j++ ) {
        if (pow == i) {
          // wenn ja dann in twoPoweredBy merken.
          twoPoweredBy = j;
          break;
        }
        pow <<= 1;
      }

      if (twoPoweredBy > 0 ) {
        // ist wert aus original daten, also von model j --> newmodel i
        int exp=0;
        for (int alpha = 0; alpha < newModel.alphabet.length; alpha++) {
/*          exp = (model.getZustand(twoPoweredBy).indices[alpha] - 1);
          if (exp >= 0) {
            pow = 1;
            pow <<= exp;
            newModel.getZustand(i).indices[alpha] = pow;
          } else newModel.getZustand(i).indices[alpha] = 0; */
        newModel.getZustand(i).indices[alpha] = model.getZustand(twoPoweredBy).indices[alpha];
        }
      } else {
        for (int k=0; k<i; k++) {
          if ( (k & i) != 0 ) {
            // wenn ein k element der Menge i (binr)
            // oder die Werte
            for (int alpha = 0; alpha < newModel.alphabet.length; alpha++)
              newModel.getZustand(i).indices[alpha] |= newModel.getZustand((k&i)).indices[alpha];
          }
        }
      }

    }

    for (int j=0; j<model.getRowCount(); j++ )
      if (model.getZustand(j).accepted)
        for (int i=1; i<newModel.getRowCount(); i++) {
          pow = 1;
          pow <<= j;
          if ( (i & pow) != 0) newModel.getZustand(i).accepted = true;
        }

    newModel.isDEA = true;
    table.setModel(newModel);

  }

  void butToNEA_actionPerformed(ActionEvent e) {
    butTest.setEnabled(false);
    newModel = null;
    butNEAToDEA.setEnabled(true);
    butToNEA.setEnabled(false);
    table.setModel(model);
    cmbAccept.setEnabled(true);
    cmbValue.setEnabled(true);
    menSave.setEnabled(true);
    butNew.setEnabled(true);
  }




}